package de.tudarmstadt.realtimebeverages.domain;

import static de.tudarmstadt.realtimebeverages.domain.AssertUtils.bigDecimalCompareTo;
import static org.assertj.core.api.Assertions.assertThat;

public class OfferedItemAsserts {

    /**
     * Asserts that the entity has all properties (fields/relationships) set.
     *
     * @param expected the expected entity
     * @param actual the actual entity
     */
    public static void assertOfferedItemAllPropertiesEquals(OfferedItem expected, OfferedItem actual) {
        assertOfferedItemAutoGeneratedPropertiesEquals(expected, actual);
        assertOfferedItemAllUpdatablePropertiesEquals(expected, actual);
    }

    /**
     * Asserts that the entity has all updatable properties (fields/relationships) set.
     *
     * @param expected the expected entity
     * @param actual the actual entity
     */
    public static void assertOfferedItemAllUpdatablePropertiesEquals(OfferedItem expected, OfferedItem actual) {
        assertOfferedItemUpdatableFieldsEquals(expected, actual);
        assertOfferedItemUpdatableRelationshipsEquals(expected, actual);
    }

    /**
     * Asserts that the entity has all the auto generated properties (fields/relationships) set.
     *
     * @param expected the expected entity
     * @param actual the actual entity
     */
    public static void assertOfferedItemAutoGeneratedPropertiesEquals(OfferedItem expected, OfferedItem actual) {
        assertThat(expected)
            .as("Verify OfferedItem auto generated properties")
            .satisfies(e -> assertThat(e.getId()).as("check id").isEqualTo(actual.getId()));
    }

    /**
     * Asserts that the entity has all the updatable fields set.
     *
     * @param expected the expected entity
     * @param actual the actual entity
     */
    public static void assertOfferedItemUpdatableFieldsEquals(OfferedItem expected, OfferedItem actual) {
        assertThat(expected)
            .as("Verify OfferedItem relevant properties")
            .satisfies(e -> assertThat(e.getName()).as("check name").isEqualTo(actual.getName()))
            .satisfies(e -> assertThat(e.getStock()).as("check stock").isEqualTo(actual.getStock()))
            .satisfies(e -> assertThat(e.getPrice()).as("check price").usingComparator(bigDecimalCompareTo).isEqualTo(actual.getPrice()))
            .satisfies(e -> assertThat(e.getHidden()).as("check hidden").isEqualTo(actual.getHidden()))
            .satisfies(e -> assertThat(e.getImage()).as("check image").isEqualTo(actual.getImage()))
            .satisfies(e -> assertThat(e.getImageContentType()).as("check image contenty type").isEqualTo(actual.getImageContentType()))
            .satisfies(e ->
                assertThat(e.getLimitedStockThreshold()).as("check limitedStockThreshold").isEqualTo(actual.getLimitedStockThreshold())
            )
            .satisfies(e -> assertThat(e.getCategory()).as("check category").isEqualTo(actual.getCategory()));
    }

    /**
     * Asserts that the entity has all the updatable relationships set.
     *
     * @param expected the expected entity
     * @param actual the actual entity
     */
    public static void assertOfferedItemUpdatableRelationshipsEquals(OfferedItem expected, OfferedItem actual) {}
}
